## org.apache.commons.collections.buffer
Class UnboundedFifoBuffer

    java.lang.Object
      java.util.AbstractCollection
          org.apache.commons.collections.buffer.UnboundedFifoBuffer

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, Buffer

    public class UnboundedFifoBuffer

extends java.util.AbstractCollection
implements Buffer, java.io.Serializable

UnboundedFifoBuffer is a very efficient implementation of `Buffer` that can grow to any size. According to performance testing, it exhibits a constant access time, but it also outperforms ArrayList when used for the same purpose.

The removal order of an `UnboundedFifoBuffer` is based on the insertion order; elements are removed in the same order in which they were added. The iteration order is the same as the removal order.

The `remove()` and `get()` operations perform in constant time. The `add(Object)` operation performs in amortized constant time. All other operations perform in linear time or worse.

Note that this implementation is not synchronized. The following can be used to provide synchronized access to your `UnboundedFifoBuffer`:

       Buffer fifo = BufferUtils.synchronizedBuffer(new UnboundedFifoBuffer());

This buffer prevents null objects from being added.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0 (previously in main package v2.1)
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Avalon, Federico Barbieri, Berin Loritsch, Paul Jack, Stephen Colebourne, Andreas Schlosser, Thomas Knych, Jordan Krey
See Also:
  Serialized Form

Field Summary
`protected java.lang.Object[]` `buffer` The array of objects in the buffer.
`protected int` `head` The current head index.
`protected int` `tail` The current tail index.

Constructor Summary
`UnboundedFifoBuffer()` Constructs an UnboundedFifoBuffer with the default number of elements.
`UnboundedFifoBuffer(int initialSize)` Constructs an UnboundedFifoBuffer with the specified number of elements.

Method Summary
`boolean` `add(java.lang.Object obj)` Adds the given element to this buffer.
`java.lang.Object` `get()` Returns the next object in the buffer.
`boolean` `isEmpty()` Returns true if this buffer is empty; false otherwise.
`java.util.Iterator` `iterator()` Returns an iterator over this buffer's elements.
`java.lang.Object` `remove()` Removes the next object from the buffer
`int` `size()` Returns the number of elements stored in the buffer.

Methods inherited from class java.util.AbstractCollection
`addAll, clear, contains, containsAll, remove, removeAll, retainAll, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Collection
`addAll, clear, contains, containsAll, equals, hashCode, remove, removeAll, retainAll, toArray, toArray`

Field Detail

### buffer

    protected transient java.lang.Object[] buffer

  The array of objects in the buffer.

### head

    protected transient int head

  The current head index.

### tail

    protected transient int tail

  The current tail index.

Constructor Detail

### UnboundedFifoBuffer

    public UnboundedFifoBuffer()

  Constructs an UnboundedFifoBuffer with the default number of elements. It is exactly the same as performing the following:

         new UnboundedFifoBuffer(32);

### UnboundedFifoBuffer

    public UnboundedFifoBuffer(int initialSize)

  Constructs an UnboundedFifoBuffer with the specified number of elements. The integer must be a positive integer.

  Parameters:
    `initialSize` - the initial size of the buffer
  Throws:
    `java.lang.IllegalArgumentException` - if the size is less than 1

Method Detail

### size

    public int size()

  Returns the number of elements stored in the buffer.

  Specified by:
    `size` in interface `java.util.Collection`
  Specified by:
    `size` in class `java.util.AbstractCollection`
  Returns:
    this buffer's size

### isEmpty

    public boolean isEmpty()

  Returns true if this buffer is empty; false otherwise.

  Specified by:
    `isEmpty` in interface `java.util.Collection`
  Overrides:
    `isEmpty` in class `java.util.AbstractCollection`
  Returns:
    true if this buffer is empty

### add

    public boolean add(java.lang.Object obj)

  Adds the given element to this buffer.

  Specified by:
    `add` in interface `java.util.Collection`
  Overrides:
    `add` in class `java.util.AbstractCollection`
  Parameters:
    `obj` - the element to add
  Returns:
    true, always
  Throws:
    `java.lang.NullPointerException` - if the given element is null

### get

    public java.lang.Object get()

  Returns the next object in the buffer.

  Specified by:
    `get` in interface `Buffer`
  Returns:
    the next object in the buffer
  Throws:
    `BufferUnderflowException` - if this buffer is empty

### remove

    public java.lang.Object remove()

  Removes the next object from the buffer

  Specified by:
    `remove` in interface `Buffer`
  Returns:
    the removed object
  Throws:
    `BufferUnderflowException` - if this buffer is empty

### iterator

    public java.util.Iterator iterator()

  Returns an iterator over this buffer's elements.

  Specified by:
    `iterator` in interface `java.lang.Iterable`
  Specified by:
    `iterator` in interface `java.util.Collection`
  Specified by:
    `iterator` in class `java.util.AbstractCollection`
  Returns:
    an iterator over this buffer's elements

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.